<?php
/**
 * @version		bookingWizard 2009-11-09 
 * @package		Joomla
 * @subpackage	Content
 * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
*/

// no direct access
defined( '_JEXEC' ) or die( 'Direct Access not allowed.' );

/**
 * This is the main Filter code, which should
 * remain the same thro joomla 1.5, 1.6 and 1.7
 *
 * Wizard Widgets:
 * bookingsheet, administration, availability, property
 *
**/


// Ver 1.3b : Adding Language support
// Ver 1.4  : Adding BookingSheet Widget
// Ver 1.6  : align with XML version number"'.$subDom.'"

function booking_filterContent($content, $expression, $config) {

		switch($config['layout']) {
			default:
			case "classic":
				$config['height']="420";
				$config['width']="630";
				break;

			case "banner":
				$config['height']="220";
				$config['width']="700";
				break;

			case "tower":
				$config['height']="550";
				$config['width']="210";
				break;
		}

		$runLocal=false;
		$subDom="www";
		if ($runLocal) {
			$subDom="dev";
		}
		$scriptExtra='';

		$output='<script type="text/javascript" src="//'.$subDom.'.bookingwizard.net/js/Calendar.js?ver=1"></script>';
				
		// find tags in content-text
		preg_match_all($expression, $content, $matches);
		$cnt=0;
		if ( isset($matches[1])) {
			foreach($matches[1] as $wparam ) {
				@list(, $replStr) = each($matches[0]);
				@list($type,$code,$style) =  split(",",$wparam,3);
				$type=strtolower(trim($type));
				$code=trim($code);
				$style=trim($style);

				switch($type) {

					case "bookingsheet":
						// NOTE: variable $code, actually contains the styling.
						//
						$height=200;
						$width=870;

						// Check if styling contains height code?
						$styleStrip=str_replace(" ", "", strtolower($code));
						$index=strpos($style, "height:");
						if ( $index !== false ) {
							preg_match("/height:(.*)px;/U", $styleStrip, $matches);
							if ( is_numeric($matches[1]) ) {
								$newHeight=$matches[1];
								if ($newHeight > 50 ) {
									$height=$newHeight;
								} 
							}
						}
						$index=strpos($styleStrip, "width:");
						if ( $index !== false ) {
							preg_match("/width:(.*)px;/U", $styleStrip, $matches);
							if ( is_numeric($matches[1]) ) {
								$newWidth=$matches[1];
								if ($newWidth > 100 ) {
									$width=$newWidth;
								}
							}
						}

						if ( $runLocal ) {
							$scriptExtra='sheet.setSub("'.$subDom.'");';
						}
						$output .= '<div class="'.$config['classid'].'_sheet" style="'.$code.'" id="targ_sheet"></div>
			<script type="text/javascript">
			<!--
				var sheet = new BookingSheet("'.$config['account'].'");
				sheet.setFrameBorder('.$config['debug'].');
				sheet.setHeight("'.$height.'");
				sheet.setWidth("'.$width.'");
				sheet.setScroll("no");
				sheet.setFontSize("70%");
				sheet.setTarget("targ_sheet");
				'.$scriptExtra.'
				sheet.show();
			-->
			</script>';
				break;





					case "administration":
						if ( $runLocal ) {
							$scriptExtra='admin.setSub("'.$subDom.'");';
						}
						$output = '<div class='.$config['classid'].'_admin style="'.$code.'" id=targ_admin></div>
							<script type="text/javascript" src="//'.$subDom.'.bookingwizard.net/js/Admin.js"></script>
			<script type="text/javascript">
			<!--
				var admin = new Admin(720, 600, "'.$config['account'].'");
				admin.setTarget("targ_admin");
				admin.setFrameBorder('.$config['debug'].');
				'.$scriptExtra.'
				admin.show();
			-->
			</script>';
					break;




					case "availability":
						if ( $runLocal ) {
							$scriptExtra='avail.setSub("'.$subDom.'");';
						}
						$output .= '<div class='.$config['classid'].'_avail style="'.$code.'" id=targ_avail></div>
			<script type="text/javascript">
			<!--
			var avail = new Availability(180, 550, "'.$config['account'].'" );
				avail.setFrameBorder('.$config['debug'].');
				'.$scriptExtra.'
				avail.setLanguage("'.$config['lang'].'");
				avail.setTarget("targ_avail");
				avail.show();
			-->
			</script>';
				break;




					case "property":

						$cnt++;
						if ( $runLocal ) {
							$scriptExtra='cal'.$cnt.'.setSub("'.$subDom.'");';
						}

						$output .= '<div class='.$config['classid'].'_property  style="'.$style.'" id=targ_'.$code.'></div>
			<script type="text/javascript">
			<!--
				//
				var cal'.$cnt.' = new Calendar('.$config['width'].', '.$config['height'].', "'.$code.'", "'.$config['account'].'");
				cal'.$cnt.'.layout("'.$config['layout'].'");
				cal'.$cnt.'.setFrameBorder('.$config['debug'].');
				'.$scriptExtra.'
				cal'.$cnt.'.setLanguage("'.$config['lang'].'");
				cal'.$cnt.'.setTarget("targ_'.$code.'");
				cal'.$cnt.'.show();
			-->
			</script>';
					break;

				default:
					$output.="<div style='color:red; font-weight: bold;'>Booking Error: Unkown type entered into the Plugin environment : $replStr<br>Check Syntax.</div>";
					break;

				}
						
				
				$content = str_replace($replStr, $output, $content);			
				$output="";

			}	
		}

	return $content;


}

?>
